#!/usr/bin/perl -w
# PLD Linux Distribution
# Maciej 'Blaass' Brylka
# gsm-sms.pl Beta 0.1 Prosze o Testy

# Potrzebne perl / Device::Gsm;
# Testowany na nokii 6310i

use Device::Gsm;
use Device::Gsm::Sms;

#use strict; // Linia 87, ulatwienia ...

my ($pin,$port,$baudrate) = "";
if ($ARGV[0]) {
if ($ARGV[0] eq "-help") { &help } 
if ($ARGV[0] eq "sms") { &smssendc($ARGV[1],$ARGV[2]); } 
if ($ARGV[0] eq "readsms") { &readsmsc }
}
print "\n",'---      ',"PLD Linux Distribution\n";
print '-----    ',"Gsm-sms.pl 0.1 PL\n";
print '-------  ',"20.10.2004\n\n";

print "Podaj port do ktorego jest podpiety telefon ",'/dev/ttyS[0-2]',"\n";
print '@gsm: ';
chomp (my $myport = <STDIN>);
print "Podaj PIN do karty sim \n";
print '@gsm: ';
chomp (my $mypin = <STDIN>);
$pin = substr($pin,0,4);
print '.------------------------------.',"\n";
print '/ Model Telefonu    / Baudrate /',"\n";
print '/------------------------------/',"\n";
print '/Siemens C35/45     /      9600/',"\n";
print '/Nokia              /     19200/',"\n";
print '/Nokia Communicator /      9600/',"\n";
print '/Standardowo        /      9600/',"\n";
print '`------------------------------`',"\n";
print '@gsm: ';
chomp ($baudrate = <STDIN>);
print "$mypin $myport $baudrate \n";

my $gsm = new Device::Gsm( port => "$port", pin => "$pin" );
 
if( $gsm->connect(baudrate => $baudrate) ) {
    print "Polaczenie zakonczylo sie pomyslnie!! \n";
} else {
    print "Przepraszamy polaczenie zakonczylo sie niepowodzeniem. (Zly Baudarate?)\n";
}
my $registered = $gsm->register();
if ($registered) { print "PIN zostal przyjety \n" } else { "Kod PIN Zostal odrzucony \n"; exit; }

my $imei = $gsm->imei();
my $rev = $gsm->software_revision();

print "Polaczony\n $imei $rev \n";
print '1) Wyslij Smsa'," \n";
print '2) Odczytaj Smsy'," \n";
print '@gsm-polaczony: ';
chomp (my $menu = <STDIN>);
if ($menu == 1) {
    print 'Podaj numer (caly np. +48505111111)',"/n"; 
    print '@gsm: ';
    chomp(my $numer = <STDIN>);
    print 'Wpisz tresc',"/n";
    print '@gsm: ';
    chomp(my @tresc = <STDIN>);
    &smssend($gsm, $numer,@tresc);
}
if ($menu == 2) {
    &smsread($gsm); 
}
sub smsread {
    my $gsm = shift;
    my @messages = $gsm->messages();
    my $info = scalar @messages;

    if($info) {
	print "Sa wiadomosci !!!\n";
    
    my $k = 0;
    foreach (@messages) {
	my $sms = $_;
	next unless defined $sms;
	print '-' x 60, "\n", "Wiadomosc numer $k\n";
	print 'Typ    ',($sms->type() eq Device::Gsm::Sms::SMS_SUBMIT ? 'SUBMIT' : 'DELIVER'), "\n";
	print 'Status ', $sms->status(), "\n";
	print 'Od   ', $sms->sender(), "\n";
	print 'Do     ', $sms->recipient(), "\n";
	print 'Tekst   [', $sms->text(), "]\n";
	$k++;
	<STDIN>;
        }
    } else { print "Nie ma zadnych wiadomosci na karcie Sim\n"; }
 exit;
}
sub smsreadc {
    my $gsm = new Device::Gsm( port => "$port", pin => "$pin" );
    
    if( $gsm->connect(baudrate => $baudrate) ) {
        print "Polaczenie zakonczylo sie pomyslnie!! \n";
    } else {
        print "Przepraszamy polaczenie zakonczylo sie niepowodzeniem. (Zly Baudarate?)\n";
    }

    my $registered = $gsm->register();
    if ($registered) { print "PIN zostal przyjety \n" } else { "Kod PIN Zostal odrzucony \n"; exit; }
    &smsread($gsm);
} 
sub smssendc {
    my ($numer,@tresc) = (@_);
    my $gsm = new Device::Gsm( port => "$port", pin => "$pin" );
    
    if( $gsm->connect(baudrate => $baudrate) ) {
        print "Polaczenie zakonczylo sie pomyslnie!! \n";
    } else {
        print "Przepraszamy polaczenie zakonczylo sie niepowodzeniem. (Zly Baudarate?)\n";
    }

    my $registered = $gsm->register();
    if ($registered) { print "PIN zostal przyjety \n" } else { "Kod PIN Zostal odrzucony \n"; exit; }
    &smssend($gsm,$numer,@tresc);
}

sub smssend {
    my ($gsm,$numer,@tresc) = (@_);
    my $sent = $gsm->send_sms(
        recipient => "$numer",
        content   => "@tresc"
    );
    if( $sent ) {
	print "Sms wyslany !\n";
    } else {
        print "Blad !! Napewno zaplaciles rachunek ??\n"
    }
 exit;
}
sub help {
    print "\n",'---      ',"PLD Linux Distribution\n";
    print '-----    ',"Gsm-sms.pl 0.1 PL\n";
    print '-------  ',"20.10.2004\n\n";
    print "Dostepne argumenty \n";
    print '-------',"\n";
    print " perl gsm-sms.pl sms numer tresc\n";
    print " opcja ta wysyla wiadomosc SMS pod podany numer\n";
    print " np. perl gsm-sms.pl +48505111111 Hej misia, co u Ciebie ?\n";
    print '-------',"\n";
    print " perl gsm-sms.pl readsms\n";
    print " opcja ta wyswietli wszystkie SMSy na karcie SIM\n\n\n";
    exit;
}